Bug 690360 - Review Request: weave - Firefox Registration/Sync Server
Review Request: weave - Firefox Registration/Sync Server
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
noarch Linux
unspecified Severity medium
: ---
: ---
Assigned To: Miroslav Suchý
Fedora Extras Quality Assurance
Stalled Submitter
:
Depends On:
Blocks: FE-DEADREVIEW
  Show dependency treegraph
 
Reported: 2011-03-24 00:06 EDT by Justin Morgan
Modified: 2012-08-04 12:39 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-04 12:39:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Justin Morgan 2011-03-24 00:06:43 EDT
Spec URL: http://matrix.senecac.on.ca/~jpmorgan/SPECS/weave.spec
SRPM URL: http://matrix.senecac.on.ca/~jpmorgan/SRPMS/httptunnel-3.0.5-1.fc14.src.rpm
SOURCE URL: http://matrix.senecac.on.ca/~jpmorgan/SOURCES/weave-0.1-1.tar.gz

Description: Firefox Sync and Registration Server

First packaged created/released. Look forward to your review!
Comment 1 Justin Morgan 2011-03-24 00:18:46 EDT
Apologies. Incorrect SRPM URL link. Here's the correct one:

http://matrix.senecac.on.ca/~jpmorgan/SRPMS/weave-0.1-1.fc14.src.rpm
Comment 2 Fabian Affolter 2011-03-28 05:31:06 EDT
Are the BuildRequires really needed? Please preserve the timestamps (https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps).
Comment 3 Justin Morgan 2011-03-28 23:05:24 EDT
(In reply to comment #2)
> Are the BuildRequires really needed? Please preserve the timestamps
> (https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps).

No they aren't. Thank you for pointing that out. I've also added -p arguments to preserve timestamps.

Here's the 0.1-2 release with your recommended changes:

SPEC: http://matrix.senecac.on.ca/~jpmorgan/SPECS/weave.spec
SRPM: http://matrix.senecac.on.ca/~jpmorgan/SRPMS/weave-0.1-2.fc14.src.rpm
SOURCE: http://matrix.senecac.on.ca/~jpmorgan/SOURCES/weave-0.1-2.tar.gz
Comment 4 Justin Morgan 2011-04-03 18:59:33 EDT
Updated spec file to release 3:

http://matrix.senecac.on.ca/~jpmorgan/SPECS/weave.spec
Comment 5 Chris Tyler 2011-04-09 15:46:45 EDT
Release 3 spec doesn't work with the release 2 sources and no SRPM was provided, so I used the release 2 SRPM for an initial review:

[Y] MUST: rpmlint must be run on every package. The output should be posted in the review.

2 packages and 1 specfiles checked; 0 errors, 0 warnings.

[Y] MUST: The package must be named according to the Package Naming Guidelines .
[Y] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[Y] MUST: The package must meet the Packaging Guidelines.
[Y] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[?] MUST: The License field in the package spec file must match the actual license.

-> How do you know the actual license?

[NA] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[Y] MUST: The spec file must be written in American English.
[Y] MUST: The spec file for the package MUST be legible.
[N] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

-> Is the tarball not directly obtainable from the upstream source? If so, give the URL to the upstream location.

[Y] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[NA for PA] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[Y] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[Y] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[Y] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[Y] MUST: Packages must NOT bundle copies of system libraries.
[NA] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[N] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

-> Package does not own /usr/share/weave but should (directory is exclusive to this package)

[N] MUST: A Fedora package must not list a file more than once in the spec file's %files listings.

-> file listed twice: /etc/httpd/conf.d/weave.conf

[Y] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[N] MUST: Each package must consistently use macros.

-> Do not use both $RPM_BUILD_ROOT and %{buildroot} in the spec file.

[Y] MUST: The package must contain code, or permissable content.
[NA] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[Y] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[NA] MUST: Header files must be in a -devel package.
[NA] MUST: Static libraries must be in a -static package.
[NA] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[NA] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[Y] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[NA] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[N] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.

-> Package owns /etc/httpd/conf.d but should not (directory is owned by httpd)

[Y] MUST: All filenames in rpm packages must be valid UTF-8.



SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.

[Y] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.

-> How do you know the license that applies to this package?

[N] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[Y] SHOULD: The reviewer should test that the package builds in mock.
[Y] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[-] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[NA] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[NA] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[NA] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[NA] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[NA] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


Also:
-> README files under /usr/share/weave/ should be %doc
-> There's a dependency on mysql-server, but the server might be installed on another host. No dependencies are usually set on database servers for this reason.

-> Question: Should Aliases in weave.conf be commented out by default, until the user enables the server?
Comment 6 Justin Morgan 2011-04-10 22:46:19 EDT
(In reply to comment #5)
> [?] MUST: The License field in the package spec file must match the actual
> license.
> 
> -> How do you know the actual license?

Answer: The license I've used comes from the License block contained in the PHP files (Ex. reg-server/1.0/index.php). It's also the standard Mozilla tri-license. Latest release (0.2-1) reflects this.

> [N] MUST: The sources used to build the package must match the upstream source,
> as provided in the spec URL. Reviewers should use md5sum for this task. If no
> upstream URL can be specified for this package, please see the Source URL
> Guidelines for how to deal with this.
> 
> -> Is the tarball not directly obtainable from the upstream source? If so, give
> the URL to the upstream location.

Answer: Unfortunately there are two separate upstream sources for this version of weave, one for sync-server and another for reg-server. These "source" tar-balls also contain mercurial files that I've manually stripped to create my own sources.

> [N] MUST: A package must own all directories that it creates. If it does not
> create a directory that it uses, then it should require a package which does
> create that directory.
> 
> -> Package does not own /usr/share/weave but should (directory is exclusive to
> this package)

* Corrected in 0.2-1

> [N] MUST: A Fedora package must not list a file more than once in the spec
> file's %files listings.
> 
> -> file listed twice: /etc/httpd/conf.d/weave.conf

* Corrected in 0.2-1

> [N] MUST: Each package must consistently use macros.
> 
> -> Do not use both $RPM_BUILD_ROOT and %{buildroot} in the spec file.

* Corrected in 0.2-1

> [N] MUST: Packages must not own files or directories already owned by other
> packages. The rule of thumb here is that the first package to be installed
> should own the files or directories that other packages may rely upon. This
> means, for example, that no package in Fedora should ever share ownership with
> any of the files or directories owned by the filesystem or man package. If you
> feel that you have a good reason to own a file or directory that another
> package owns, then please present that at package review time.
> 
> -> Package owns /etc/httpd/conf.d but should not (directory is owned by httpd)

* Corrected in 0.2-1

> [N] SHOULD: The description and summary sections in the package spec file
> should contain translations for supported Non-English languages, if available.

Answer: All Weave documentation is currently in English. Both in README's and from Mozilla web documentation.

> Also:
> -> README files under /usr/share/weave/ should be %doc

Answer: Those README's are no longer included with the latest source, as they include manual installation instructions no longer applicable for the packaged version.

> -> There's a dependency on mysql-server, but the server might be installed on
> another host. No dependencies are usually set on database servers for this
> reason.

* Corrected in 0.2-1

> -> Question: Should Aliases in weave.conf be commented out by default, until
> the user enables the server?

Answer: I'm a bit confused how to accomplish this. The only enabling the user does is apply the MySQL script (no BASH/etc). If you have any thoughts on how I may go about this I would certainly like to give it a shot.

----------------------------------------

Release 0.2-2

SPEC: http://matrix.senecac.on.ca/~jpmorgan/SPECS/weave.spec
SOURCE: http://matrix.senecac.on.ca/~jpmorgan/SOURCES/weave-0.2.tar.gz
SRPM: http://matrix.senecac.on.ca/~jpmorgan/SRPMS/weave-0.2-1.fc14.src.rpm
RPM: http://matrix.senecac.on.ca/~jpmorgan/RPMS/weave-0.2-1.fc14.noarch.rpm

Apologies for the issue you had finding the source last time. I'm ensuring the project wiki is updated with "all" the latest links if you have any further issues.
Comment 7 Justin Morgan 2011-04-10 22:47:27 EDT
(In reply to comment #6)
> Release 0.2-2
> 
> SPEC: http://matrix.senecac.on.ca/~jpmorgan/SPECS/weave.spec
> SOURCE: http://matrix.senecac.on.ca/~jpmorgan/SOURCES/weave-0.2.tar.gz
> SRPM: http://matrix.senecac.on.ca/~jpmorgan/SRPMS/weave-0.2-1.fc14.src.rpm
> RPM: http://matrix.senecac.on.ca/~jpmorgan/RPMS/weave-0.2-1.fc14.noarch.rpm
> 
> Apologies for the issue you had finding the source last time. I'm ensuring the
> project wiki is updated with "all" the latest links if you have any further
> issues.

That should be Release 0.2-1.
Comment 8 Chris Tyler 2011-04-11 09:38:01 EDT
Justin, you should be using upstream's tarballs directly (pristine sources) and do any stripping/processing in your %prep section. There's two reasons for this: first, it relieves you of the responsibility of serving that tarball indefinitely, and secondly, it makes it easier to see how the software is different from the upstream version (or confirm that it is not).

Either list two sources (e.g., Source0 and Source1) with the URLs for each of the tarballs, or separate this into two packages, one for the reg-server and one for the sync-server. Whether it makes sense to go with one package (and two sources) or two packages is best determined by the answer to this question: is there any foreseeable circumstance under which you would use one server but not the other?

My suggestion about aliases was this: you want to provide the 'least surprise' to the sysadmin installing your package. I recommend that the Alias lines in the httpd weave.conf file be commented out (have a '#' at the start of each line) so that the weave server doesn't automatically start serving as soon as it is installed (or more likely and worse yet: it doesn't start serving when installed, but does start installing after the next boot or httpd restart). After all, the sysadmin has to configure the DB connection, and may also want to do virtual host configuration, etc. In your README, include instructions to uncomment those lines *after* the DB configuration has been performed.

(Note that other web app packages such as mediawiki take this approach).
Comment 9 Justin Morgan 2011-04-12 19:50:11 EDT
(In reply to comment #8)
> Justin, you should be using upstream's tarballs directly (pristine sources) and
> do any stripping/processing in your %prep section. There's two reasons for
> this: first, it relieves you of the responsibility of serving that tarball
> indefinitely, and secondly, it makes it easier to see how the software is
> different from the upstream version (or confirm that it is not).
> 
> Either list two sources (e.g., Source0 and Source1) with the URLs for each of
> the tarballs, or separate this into two packages, one for the reg-server and
> one for the sync-server. Whether it makes sense to go with one package (and two
> sources) or two packages is best determined by the answer to this question: is
> there any foreseeable circumstance under which you would use one server but not
> the other?
> 
> My suggestion about aliases was this: you want to provide the 'least surprise'
> to the sysadmin installing your package. I recommend that the Alias lines in
> the httpd weave.conf file be commented out (have a '#' at the start of each
> line) so that the weave server doesn't automatically start serving as soon as
> it is installed (or more likely and worse yet: it doesn't start serving when
> installed, but does start installing after the next boot or httpd restart).
> After all, the sysadmin has to configure the DB connection, and may also want
> to do virtual host configuration, etc. In your README, include instructions to
> uncomment those lines *after* the DB configuration has been performed.
> 
> (Note that other web app packages such as mediawiki take this approach).

Hello Chris,

The package has been updated to use the Mercurial upstream sources (in addition to tag-date version).

I've also as you suggested comment out the weave conf and updated the readme to instruct the installer how to enable Weave services.

weave-20110314-1

SPEC: http://matrix.senecac.on.ca/~jpmorgan/SPECS/weave.spec
SRPM: http://matrix.senecac.on.ca/~jpmorgan/SRPMS/weave-20110314-1.fc14.src.rpm
RPM: http://matrix.senecac.on.ca/~jpmorgan/RPMS/weave-20110314-1.fc14.noarch.rpm
Comment 10 Matthias Runge 2011-09-01 09:34:54 EDT
Any progress here?
Comment 11 Kanwar Ranbir Sandhu 2011-10-16 12:55:23 EDT
Bug info says it's not assigned to anyone.  Does that mean there's no one working on the RPM or there's no one reviewing the submitted package?

If the original submitter has abandoned the effort, I will consider taking it over.  My RPM building skills aren't the greatest.  I'll give it my best. :)
Comment 12 Miroslav Suchý 2011-10-17 09:00:57 EDT
It means that no one is reviewing it. I want to review it, but it is still in my queue, so I did not step in. Yet.
Comment 13 Miroslav Suchý 2011-10-23 18:59:02 EDT
* LGPLv2.1 is unknown abbreviation of license. Check http://fedoraproject.org/wiki/Licensing:Main For LGPLv2.1 should be used just LGPLv2.
* weave.src: W: invalid-url Source0: http://hg.mozilla.org/services/sync-server/archive/bc2f6caf8fc8.tar.bz2 - can you update it please (I know it is not your fault and it has been changed since April).
* There is no need to specify build root now. 
  http://fedoraproject.org/wiki/Packaging:Guidelines#BuildRoot_tag
* similary to %clean section:
  http://fedoraproject.org/wiki/Packaging:Guidelines#.25clean
* Version: 20110314;Release:  1%{?dist}
  Hmm, according http://hg.mozilla.org/services/server-full they use version 0.1 number till August. I would recommend you reading of:
  http://fedoraproject.org/wiki/Packaging:NamingGuidelines#Snapshot_packages
  And in April I would use:
  Version: 0.1
  Release: 1.20110314hg
  If you would use version as you used, then upgrade to version e.g. 1.5 would be impossible without usage of epoch (which is alway good to avoid).
* In weave.conf:
  #Alias /user/1.0 /usr/share/weave/reg-server-2a73b7376e2c/1.0/index.php                                                                      #Alias /user/1 /usr/share/weave/reg-server-2a73b7376e2c/1.0/index.php
  Wow, that is ugly. That means, that whenever you modify your %{sync} and %{reg} macro (probably every release). Admin will have to manually upgrade weave.conf to have workable configuration. Why can't you just use reg-server and sync-server, without that commit number?
Comment 14 Matthias Runge 2012-02-27 15:54:20 EST
Any progress here?

Kanwar, if you're going to submit this as review, please open a new review request.
Comment 15 Miroslav Suchý 2012-08-04 12:39:51 EDT
closing per #14
if you want continue, either reopen or open new request

Note You need to log in before you can comment on or make changes to this bug.